option casemap:none
option procalign:16
;option frame:auto

UNICODE 				EQU 1
WIN32_LEAN_AND_MEAN 	EQU 1
_WIN64 					EQU 1

include \Win32Inc\Include\windows.inc
include Test64.Inc
includelib Kernel32.Lib
includelib User32.Lib
includelib msvcrt.lib

; msvcrt requied
kbhit proto c
getch proto c

;__chkstk proto
uqw2wsz proto :QWORD,:PWCHAR
sqw2wsz proto :SQWORD,:PWCHAR
qw2hexwsz proto :QWORD,:PWCHAR
wszSize proto :PWCHAR
wszcMultiCat proto :PWCHAR,:QWORD,:QWORD,:VARARG
ConsoleOut proto pwsz:PWCHAR
print_wsz proto nArgs:QWORD,pwszArgs:VARARG
wait_key proto

.data?

hInstance 	HINSTANCE ?

.code
main proc
LOCAL wsz[128]:WCHAR

	and rsp,-16
	
	counter_begin 1000000, HIGH_PRIORITY_CLASS
		REPEAT 30
			push rax
			push rbx
			push rcx
			push rdx
			push rbp
			push rsp
			push rdi
			push rsi
			push r8  
			push r9  
			push r10  
			push r11 
			push r12  
			push r13  
			push r14  
			push r15
		ENDM
		add rsp,30*8*16
	counter_end
	invoke sqw2wsz,rax,ADDR wsz
	print "push: ",ADDR wsz,wsz$(13,10)

	counter_begin 1000000, HIGH_PRIORITY_CLASS
		sub rsp,30*8*16
		cntr = 0
		REPEAT 30
			mov [rsp+ cntr*16*8 + 00*8],rax
			mov [rsp+ cntr*16*8 + 01*8],rbx
			mov [rsp+ cntr*16*8 + 02*8],rcx
			mov [rsp+ cntr*16*8 + 03*8],rdx
			mov [rsp+ cntr*16*8 + 04*8],rbp
			mov [rsp+ cntr*16*8 + 05*8],rsp
			mov [rsp+ cntr*16*8 + 06*8],rdi
			mov [rsp+ cntr*16*8 + 07*8],rsi
			mov [rsp+ cntr*16*8 + 08*8],r8  
			mov [rsp+ cntr*16*8 + 09*8],r9  
			mov [rsp+ cntr*16*8 + 10*8],r10  
			mov [rsp+ cntr*16*8 + 11*8],r11 
			mov [rsp+ cntr*16*8 + 12*8],r12  
			mov [rsp+ cntr*16*8 + 13*8],r13  
			mov [rsp+ cntr*16*8 + 14*8],r14  
			mov [rsp+ cntr*16*8 + 15*8],r15
			cntr  = cntr  + 1
		ENDM
		add rsp,30*8*16
	counter_end
	invoke sqw2wsz,rax,ADDR wsz
	print "mov: ",ADDR wsz,wsz$(13,10)
	
	counter_begin 1000000, HIGH_PRIORITY_CLASS
		REPEAT 30
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
			push BYTE ptr 100
		ENDM
		add rsp,30*8*16
	counter_end
	invoke sqw2wsz,rax,ADDR wsz
	print "push const: ",ADDR wsz,wsz$(13,10)

	counter_begin 1000000, HIGH_PRIORITY_CLASS
		sub rsp,30*8*16
		cntr = 0
		REPEAT 30
			mov [rsp+ cntr*16*8 + 00*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 01*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 02*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 03*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 04*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 05*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 06*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 07*8], BYTE ptr 100
			mov [rsp+ cntr*16*8 + 08*8], BYTE ptr 100 
			mov [rsp+ cntr*16*8 + 09*8], BYTE ptr 100 
			mov [rsp+ cntr*16*8 + 10*8], BYTE ptr 100  
			mov [rsp+ cntr*16*8 + 11*8], BYTE ptr 100 
			mov [rsp+ cntr*16*8 + 12*8], BYTE ptr 100  
			mov [rsp+ cntr*16*8 + 13*8], BYTE ptr 100  
			mov [rsp+ cntr*16*8 + 14*8], BYTE ptr 100  
			mov [rsp+ cntr*16*8 + 15*8], BYTE ptr 100
			cntr  = cntr  + 1
		ENDM
		add rsp,30*8*16
	counter_end
	invoke sqw2wsz,rax,ADDR wsz
	print "mov const: ",ADDR wsz,wsz$(13,10)

	inkey

	ret
main endp


option prologue:none
option epilogue:none

;experimental
uqw2wsz proc uqw:QWORD,pwszBuffer:PWCHAR

	mov r8,0CCCCCCCCCCCCCCCDh
	xor r9,r9
	xor r10,r10
	xor r11,r11
	mov rax,rcx
	mov rcx,rdx
	align 16	
@@:	
	mul r8
	shrd rax,rdx,3
	push rdx
	inc rax
	mov rdx,10
	mul rdx
	lea r9,[r9+rdx]
	shld r10,r9,4
	shl r9,4
	pop rax
	shr rax,3
	lea r11,[r11+1]
	jnz @B
	shrd r9,r10,4
	shr r10,4
	align 16
@@:	
	mov rax,r9
	and rax,0fh
	add rax,30h
	mov WORD ptr [rcx],ax
	shrd r9,r10,4
	shr r10,4
	lea rcx,[rcx+2]
	dec r11
	jnz @B
@@:
	mov WORD ptr [rcx],0
	ret

uqw2wsz endp

;experimental
sqw2wsz proc sqw:SQWORD,pwszBuffer:PWCHAR

	mov r8,0CCCCCCCCCCCCCCCDh
	xor r9,r9
	xor r10,r10
	xor r11,r11
	test rcx,rcx
	.if SIGN?
		neg rcx
		mov WORD ptr [rdx],'-'
		lea rdx,[rdx+2]
	.endif
	mov rax,rcx
	mov rcx,rdx
	align 16	
@@:	
	mul r8
	shrd rax,rdx,3
	push rdx
	inc rax
	mov rdx,10
	mul rdx
	lea r9,[r9+rdx]
	shld r10,r9,4
	shl r9,4
	pop rax
	shr rax,3
	lea r11,[r11+1]
	jnz @B
	shrd r9,r10,4
	shr r10,4
	align 16
@@:	
	mov rax,r9
	and rax,0fh
	add rax,30h
	mov WORD ptr [rcx],ax
	shrd r9,r10,4
	shr r10,4
	lea rcx,[rcx+2]
	dec r11
	jnz @B
@@:
	mov WORD ptr [rcx],0
	ret

sqw2wsz endp

qw2hexwsz proc qwValue:QWORD,pwszBuffer:PWCHAR
	
	.data
		align 32
		q2hws_msk1	QWORD 0f0f0f0f0f0f0f0f0h
		q2hws_msk2	QWORD 00f0f0f0f0f0f0f0fh
		q2hws_msk3	OWORD 30303030303030303030303030303030h
		q2hws_msk4	OWORD 09090909090909090909090909090909h
		q2hws_msk5	OWORD 07070707070707070707070707070707h
	.code
	
	pxor xmm4,xmm4
	mov r8,rcx
	and rcx,q2hws_msk1
	and r8,q2hws_msk2
	shr rcx,4

	movd xmm0,r8
	movd xmm1,r8
	movd xmm2,rcx
	punpcklbw xmm0,xmm2
	punpcklbw xmm1,xmm2
	por xmm0,xmm1
	movdqa xmm1,xmm0
	paddb xmm0,q2hws_msk3
	pcmpgtb xmm1,q2hws_msk4
	pand xmm1,q2hws_msk5
	paddb xmm0,xmm1
	movdqa xmm1,xmm0
	punpckhbw xmm0,xmm4
	punpcklbw xmm1,xmm4
	pshuflw xmm0,xmm0,00011011y
	pshufhw xmm0,xmm0,00011011y
	pshuflw xmm1,xmm1,00011011y
	pshufhw xmm1,xmm1,00011011y
	pshufd xmm0,xmm0,01001110y
	pshufd xmm1,xmm1,01001110y
	
	test rdx,0fh
	.if ZERO?
		movdqa [rdx+0*16],xmm0
		movdqa [rdx+1*16],xmm1
		mov WORD ptr [rdx+2*16],0
		ret
	.else
		movdqu [rdx+0*16],xmm0
		movdqu [rdx+1*16],xmm1
		mov WORD ptr [rdx+2*16],0		
		ret
	.endif

qw2hexwsz endp


; modifies: rax
; rcx will remain unaffected 
wszSize proc pwsz:PWCHAR
	
	xor rax,rax
@@:	test WORD ptr [rcx+rax*2],0ffffh
	lea rax,[rax+1]
	jnz @B
@@:	dec rax
	ret

wszSize endp

; MODIFIES:	rax,r8,r9,r10,r11
; rcx and rdx will remain unaffected
; REETUEN: rax = size of new string in characters (without term. zero). 
;                If the buffer is to small, zero is returned. However,
;                as long as ccBuffer is not zero an termination zero is 
;                written to buffer.
wszcMultiCat proc pwszBuffer:PWCHAR,ccBuffer:QWORD,nArgs:QWORD,pwszArgs:VARARG

	test rdx,rdx
	jz @E
	mov r10,5
	xor rax,rax
	align 8
@@:	test WORD ptr [rcx+rax*2],0ffffh
	jz @F
	cmp rax,rdx
	jae @O
	lea rax,[rax+1]
	jmp @B
@@:	
	test r8,r8
	jz @1
	@L:	movzx r11,WORD ptr [r9]
		test r11,r11
		jz @F
		mov [rcx+rax*2],r11w
		lea rax,[rax+1]
		cmp rax,rdx
		jae @O
		lea r9,[r9+2]
		jmp @L
	@@:	
		dec r8
		jz @1
		mov r9,[rsp+r10*8]
		lea r10,[r10+1]
		jmp @L

	align 16
@1:	mov WORD ptr [rcx+rax*2],0
	ret

	align 16
@O:	mov WORD ptr [rcx+rax*2-2],0
@E:	xor rax,rax
	ret

wszcMultiCat endp

option prologue:PrologueDef
option epilogue:EpilogueDef

print_wsz proc uses rsi nArgs:QWORD,pwszArgs:VARARG
LOCAL hStdOut:HANDLE
LOCAL qwWritten:QWORD
LOCAL ConsoleCP:QWORD
LOCAL cbBytes:QWORD
LOCAL psz:PCHAR	
	
	and rsp,-16
	add rsp,-8*8
	
	mov nArgs,rcx
	
	mov pwszArgs[0],rdx
	mov pwszArgs[8],r8
	mov pwszArgs[16],r9
	
	mov rcx,STD_OUTPUT_HANDLE
	call GetStdHandle
	mov hStdOut,rax
	
	mov rcx,rax
	call GetFileType
	mov rsi,rax
	
	lea rdx,qwWritten
	mov rcx,hStdOut
	call GetConsoleMode
	
	.if rsi & FILE_TYPE_CHAR && rax
		lea rsi,pwszArgs
		.while nArgs
			mov rcx,[rsi]
			call wszSize
		
			mov QWORD ptr [rsp+4*8],0
			lea r9,qwWritten
			mov r8,rax
			mov rdx,rcx
			mov rcx,hStdOut
			call WriteConsole
		
			lea rsi,[rsi+8]
			dec nArgs
		.endw
		ret
	.else
		call GetConsoleOutputCP
		mov ConsoleCP,rax
		
		lea rsi,pwszArgs
		.while nArgs
			xor rdx,rdx
			mov [rsp+32+0*8],rdx
			mov [rsp+32+1*8],rdx
			mov [rsp+32+2*8],rdx
			mov [rsp+32+3*8],rdx
			mov r9,-1
			mov r8,[rsi]
			mov rcx,ConsoleCP
			call WideCharToMultiByte
			mov cbBytes,rax
		@@:	test rax,rax
			jz @F	
			
			mov rdx,rax
			mov rcx,GPTR
			call GlobalAlloc
			mov psz,rax
			
			mov rdx,cbBytes
			mov [rsp+32+0*8],rax
			mov [rsp+32+1*8],rdx
			xor rdx,rdx
			mov [rsp+32+2*8],rdx
			mov [rsp+32+3*8],rdx
			mov r9,-1
			mov r8,[rsi]
			mov rcx,ConsoleCP
			call WideCharToMultiByte
			
			mov QWORD ptr [rsp+4*8],0
			lea r9,qwWritten
			mov r8,cbBytes
			lea r8,[r8-1]
			mov rdx,psz
			mov rcx,hStdOut
			call WriteFile
			
			mov rcx,psz
			call GlobalFree
		@@:
			lea rsi,[rsi+8]
			dec nArgs
		.endw
		ret
	.endif	

print_wsz endp

wait_key proc
LOCAL args[4]:QWORD
	
	invoke FlushConsoleInputBuffer,rv(GetStdHandle,STD_INPUT_HANDLE)
	
  @@:
  	mov rcx,1
    call Sleep
    call kbhit
    test eax, eax
    jz @B

    call getch
    ret

wait_key endp


end main
